/* This sketch tests the LCD and allows you to type something on the
     Serial monitor and it shows up on the LCD
*/

/*-----( Import needed libraries )-----*/
#include <Wire.h>  // Comes with Arduino IDE
#include <LiquidCrystal_I2C.h>

/*-----( Declare Constants )-----*/
/*-----( Declare objects )-----*/
// set the LCD address to 0x27 for a 16 chars 2 line display
// A FEW use address 0x3F
// Set the pins on the I2C chip used for LCD connections:
//                    addr, en,rw,rs,d4,d5,d6,d7,bl,blpol
//LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);  // Set the LCD I2C address
LiquidCrystal_I2C lcd(0x27, 16, 2);
/*-----( Declare Variables )-----*/

int inButton = 3;
int inButtonState = 0;
int outButton = 2;
int outButtonState = 0;
float timeOut = 0;
float timeNow = 0;
long timeIn = 0;
boolean studentOut = 0;
float limit = 5;
int fadeOut = 255;
int fadeIn = 0;
int delayTime = 50;

int blue = 11  ;
int green = 10;
int red = 9;

long duration, inches;



void setup()   /*----( SETUP: RUNS ONCE )----*/
{
  Serial.begin(9600);  // Used to type in characters
  lcd.init();
  //lcd.begin(16, 2);  // initialize the lcd for 16 chars 2 lines, turn on backlight
  lcd.backlight(); // finish with backlight on

  //-------- Write characters on the display ------------------
  // NOTE: Cursor Position: (CHAR, LINE) start at 0
  
  pinMode(2, INPUT);  //
  pinMode(3, INPUT);
  pinMode(red, OUTPUT);
  pinMode(blue, OUTPUT);
  pinMode(green, OUTPUT);

  lcd.setCursor(3, 0); //Start at character 4 on line 0
  lcd.print("Welcome to");
  delay(200);
  lcd.setCursor(1, 1);
  lcd.print("Science Class");
  pinMode(8, OUTPUT);
  pinMode(7, INPUT);

  colorFun();
  lcd.clear();


  // Wait and then tell user they can start the Serial Monitor and type in characters to
  // Display. (Set Serial Monitor option to "No Line Ending")

}/*--(end setup )---*/


void loop()   /*----( LOOP: RUNS CONSTANTLY )----*/
{
  lcd.noBacklight();
   rgb(0, 50, 0);

  getDistance();
 // Serial.println(inches);
  if (inches < 20) {
    lcd.backlight();
    lcd.clear();
    lcd.setCursor(0, 0); //Start at character 0 on line 0
    lcd.print("Write your name");
    lcd.setCursor(0, 1);
    lcd.print("Push OUT Button");
    delay(500);
    rgb(0, 50, 0);
    outButtonState = digitalRead(outButton);
    delay(10);
    outButtonState = digitalRead(outButton);



    if (outButtonState == HIGH) {
      lcd.clear();
      lcd.setCursor(2, 0);
      lcd.print("Hurry Back!");
      lcd.setCursor(2, 1);
      lcd.print("5 min Limit");
      rgb(0, 0, 50);
      delay(1000);
      timeOut = millis();
      studentOut = 1;
      while (studentOut) {
        lcd.clear();
        lcd.setCursor(1, 0);
        lcd.print("SOMEONE IS OUT");
        lcd.setCursor(2, 1);
        timeNow = (millis() - timeOut) / 60000;
        lcd.print(timeNow);
        lcd.print(" ");
        lcd.print("minutes");
        delay(100);
        inButtonState = digitalRead(inButton);
        if (timeNow > limit) {
          rgb(50, 0, 0);
        }
        if ((inButtonState == 1) && (timeNow <= limit)) {
          studentOut = 0;

          lcd.clear();
          lcd.setCursor(0, 0);
          lcd.print("You were out for");
          lcd.setCursor(2, 1);
          lcd.print(timeNow);
          lcd.print(" Minutes");
          delay(5000);


        }

        if ((inButtonState == 1) && (timeNow > limit)) {
          studentOut = 0;
          lcd.clear();
          lcd.setCursor(0, 0);
          lcd.print("LIMIT VIOLATION!");
          lcd.setCursor(2, 1);
          lcd.print(timeNow);
          lcd.print(" Minutes");
          for (int i = 0; i < 20; i++) {
            rgb(0, 0, 50);
            delay(100);
            rgb(50, 0, 0);
            delay(100);
          }


        }
      }
    }
  }
  
}

void rgb (int r, int g, int b) {
  analogWrite(red, r);
  analogWrite(blue, b);
  analogWrite(green, g);
}


void colorFun() {
  rgb(0, 0, 50);
  delay(250);
  rgb(50, 0, 50);
  delay(250);
  rgb(0, 50, 50);
  delay(250);
  rgb(50, 50, 0);
  delay(250);
  rgb(50, 0, 0);
  delay(250);
  rgb(0, 50, 0);
  delay(250);

}

void getDistance() {

  digitalWrite(8, LOW);
  delayMicroseconds(2);
  digitalWrite(8, HIGH);
  delayMicroseconds(5);
  digitalWrite(8, LOW);
  duration = pulseIn(7, HIGH);
  inches = duration / 74 / 2;


}

/* ( THE END ) */